
depends 'WEAPONS'
depends 'SYSTEMS'

_G.PartUnlockReqs = _G.PartUnlockReqs or {}
_G.PartInfo = _G.PartInfo or {}
local PartInfo=PartInfo

local function merge_sets(t,...)
  t=copy(t)
  if select('#',...)==0
    return t
  end
  local t2=merge_sets(...)
  for k,v ; t2
    t[k]=v
  end
  return t
end

local medium_weapons = set("beam","kinetic","missile","anti_missile",'boarding_module')
local light_weapons = set("pd_beam","pd_kinetic",'anti_missile')

local system_types = set('system','drive','reactor','bulkheads','lab')

mount_allowed_types = {

  BioMount = set('energy_torpedo'),


  ["Heavy"] = merge_sets( light_weapons, medium_weapons, set("scanner", "blast_door", "missile", "heavy_beam", "heavy_kinetic","shield_regenerator","energy_torpedo")),
  ["Turret"] = merge_sets ( light_weapons, medium_weapons, set ("blast_door",'scanner','shield_regenerator')),
  ["Medium"] = merge_sets( light_weapons, medium_weapons, set ('scanner', 'shield_regenerator','blast_door') ),
  ["Light"] = light_weapons,
  ["Siege"] = merge_sets(set "siege",set("missile", "heavy_beam", "heavy_kinetic","energy_torpedo") ),

  ["Reactor"] = set 'reactor',
  ["Built-In"] = newproxy | catch | false,

  --["Launcher"] = set 'launcher', -- gremak only

  ["Torpedo"] = set( 'torpedo', 'missile', 'mirv'),
  ["Armor"]	=	set("armor"),
  ["Shield"]	=	set("shield"),

  Capacitor = set('capacitor','blast_door','shield_regenerator'), 

  Transport = set('cargo'),

  System = system_types,

  ['Station'] = merge_sets(system_types,set('construction','fighter','mirv','lab','warp_net')),

  Planet = merge_sets( set('shield','armor','fighter','missile','torpedo','mirv','siege', 'heavy_beam', 'heavy_kinetic', 'anti_missile'), medium_weapons,light_weapons),


  ["Missile"] = set("missile",'energy_torpedo','anti_missile'),

  ['Hangar'] = set("fighter","shuttle",'mirv'),
  Berth = set("fighter","shuttle",'mirv'),

}



mount_allowed_types.SuperHeavy = merge_sets( copy(mount_allowed_types.Heavy), set 'siege')

mount_allowed_types.Planet.boarding_module=nil

local non_weapon_mtypes = set('Station','System','Transport','Armor','Reactor','Capacitor','Shield')

function is_weapon_mtype(mtype)

  return not non_weapon_mtypes[mtype]

end



function populate_part_info()
  cleartable(PartInfo)

  for part, info ; WEAPONS
    PartInfo[part] =  info
  end

  for part,info ; SYSTEMS
    PartInfo[part] = info
  end

end




--console(t2s | part_deps['Plasma Cannon'], PartInfo['Plasma Cannon'].type )

--console(t2s ( keys(part_deps), '\n') )






